      SUBROUTINE GETRLS
C-----------------------------------------------------------------------
C! returns the name of the current release (edited each quarter in CV)
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GETRLS places the 7 characters identifying the source-code release
C   into the device common /DCHCOM/.  This routine is to be modified by
C   the AIPS Group at each release date ONLY.
C-----------------------------------------------------------------------
      CHARACTER CURRLS*8
      INCLUDE 'INCS:DDCH.INC'
C                                       Modify for new release
      DATA CURRLS /'31DEC23'/
C-----------------------------------------------------------------------
C                                       put into common
      RLSNAM = CURRLS
C
 999  RETURN
      END
